/*****************************************************************************
 *
 * FILE:	logout.c
 * DESCRIPTION:	logout CGI to destroy the session
 * DATE:	Thu, May  6 2004
 * UPDATE:	Mon, Nov  8 2004
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2004 졿Kouichi ABE (WALL), All rights reserved.
 * $Id: logout.c,v 1.3 2004/11/09 14:56:39 kouichi Exp $
 *
 *****************************************************************************/

#if	HAVE_CONFIG_H
#include "config.h"
#endif	/* HAVE_CONFIG_H */

#include <stdio.h>
#if	HAVE_STDLIB_H
#include <stdlib.h>
#endif	/* HAVE_STDLIB_H */
#if	HAVE_STRING_H
#include <string.h>
#endif	/* HAVE_STRING_H */
#include <cockatrice.h>
#include <catoblepas.h>
#include <sxml.h>
#include "session.h"

/*****************************************************************************
 *
 *	declaration of local functions
 *
 *****************************************************************************/
static int	logout(CGI *);

/*****************************************************************************
 *
 *	Functions definition
 *
 *****************************************************************************/
static int
logout(cgi)
	register CGI *	cgi;
{
  const char *	sid;
  int		ret;

  sid = cgi->param(SESSION_ID);
  if (sid == NULL) {
#if	DEBUG
    fprintf(stderr, "DEBUG[logout.cgi] level=3\n");
#endif	/* DEBUG */
    sid = cgi->cookie->get(SESSION_ID);
    if (sid == NULL) {
#if	DEBUG
      fprintf(stderr, "DEBUG[logout.cgi] level=4\n");
#endif	/* DEBUG */
      return -1;
    }
  }
  ret = cgi->session->delete_id(sid, SESSION_NAME);
  cgi->session->close(SESSION_NAME);
#if	DEBUG
  fprintf(stderr, "DEBUG[logout.cgi] ret=%d sid=%s\n", ret, sid);
#endif	/* DEBUG */

  cgi->cookie->setName(SESSION_ID, sid);
  cgi->cookie->setMaxAge(SESSION_ID, 0);	/* discard cookie */

  return ret;
}


int
main(argc, argv)
	int	argc;
	char *	argv[];
{
  CGI *	cgi;
  int	ret = -1;

#if	SESSION2
  cgi = newCGI(CC_MODULE_STANDARD|CC_MODULE_SESSION2);
#else
  cgi = newCGI(CC_MODULE_STANDARD|CC_MODULE_SESSION);
#endif	/* SESSION2 */
  if (cgi != NULL) {
    URI	uri;

#if	DEBUG
    fprintf(stderr, "DEBUG[logout.cgi] level=1\n");
#endif	/* DEBUG */
    if (read_config(argv[0], &uri) == 0) {
#if	DEBUG
      fprintf(stderr, "DEBUG[logout.cgi] level=2\n");
#endif	/* DEBUG */
      ret = logout(cgi);
#if	DEBUG
      fprintf(stderr, "DEBUG[logout.cgi] level=5\n");
#endif	/* DEBUG */
      if (ret == 0) {
	cgi->redirect(uri.login);
      }
      if (uri.login != NULL) { free((char *)uri.login); }
    }
    else {
      fprintf(stderr, "Error: failed to read %s.conf\n", argv[0]);
    }
    cgi->done();
  }

  return ret;
}

