#! /usr/bin/perl
##############################################################################
#
# FILE:		db_dump.pl
# DESCRIPTION:	Berkeley database dump tool
# DATE:		Mon, Jul 22 2002
# UPDATE:	Sat, May  8 2004
# AUTHOR:	Kouichi ABE (WALL) / 
# E-MAIL:	kouichi@MysticWALL.COM
# URL:		http://www.MysticWALL.COM/
# COPYRIGHT:	(c) 2002-2004 졿Kouichi ABE (WALL), All rights reserved.
# $Id: db_dump.pl,v 1.1 2004/05/08 07:13:11 kouichi Exp $
#
##############################################################################

use DB_File;

($program) = ($0 =~ m#([^/]+)$#);

sub dump {
  my ($name, $type) = @_;

  if ($type eq '-hash') {
    tie %DB, 'DB_File', $name, O_RDONLY|O_SHLOCK, 0600, $DB_HASH
	or die "$!:$name\n";
  }
  elsif ($type eq '-btree') {
    tie %DB, 'DB_File', $name, O_RDONLY|O_SHLOCK, 0600, $DB_BTREE
	or die "$!:$name\n";
  }
  else {
    &usage;
  }
  while (my ($key, $value) = each %DB) {
    printf "[%s] %s\n", $key, $value;
  }
  untie %DB;
}

sub usage {
  printf STDERR "usage: %s -(hash|btree) db_file\n", $program;
  exit 64;
}

&usage if ($#ARGV != 1);
&dump($ARGV[1], $ARGV[0]);
exit 0;
